unit Unit1;

{
   Droste effect (recursive image project)

   rotation buttons:
   leftmargin perc. 5--80,  default 40, btn max = 75
   topmargin  perc. 5--80,  default 10, btn max = 75
   ratio perc.     20--80,  default 50, btn max = 60
}   

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, jpeg, ComCtrls, dav7RotationBtn;

type
  TForm1 = class(TForm)
    loadBtn: TBitBtn;
    saveBtn: TBitBtn;
    reloadBtn: TBitBtn;
    PaintBox1: TPaintBox;
    xscrollbar: TScrollBar;
    yscrollbar: TScrollBar;
    clearBtn: TBitBtn;
    frameBtn1: TSpeedButton;
    framebtn2: TSpeedButton;
    frameBtn3: TSpeedButton;
    Label1: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    PaintBox2: TPaintBox;
    leftlabel: TStaticText;
    Label2: TLabel;
    toplabel: TStaticText;
    Label3: TLabel;
    ratiolabel: TStaticText;
    Label4: TLabel;
    Label5: TLabel;
    GObtn: TBitBtn;
    pipBtn: TBitBtn;
    leftrotationBtn: TDav7RotationBtn;
    toprotationBtn: TDav7RotationBtn;
    ratiorotationBtn: TDav7RotationBtn;
    pipresetBtn: TBitBtn;
    procedure loadBtnClick(Sender: TObject);
    procedure saveBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure clearBtnClick(Sender: TObject);
    procedure frameBtn1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure yscrollbarChange(Sender: TObject);
    procedure reloadBtnClick(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
    procedure GObtnClick(Sender: TObject);
    procedure pipBtnClick(Sender: TObject);
    procedure leftrotationBtnChange(sender: TObject; position: Byte);
    procedure pipresetBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure Bm2ToBox;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses xbitmap_unit,rip_unit,message_unit;

const framewidth = 12;
      defaultleftpc = 40;
      defaulttoppc = 10;
      defaultratiopc = 50;

var ratioBM : Tbitmap;
    xbias,ybias : smallInt;  //scroll positions
    framecode : byte;
    leftmarginPC : byte = 40;
    topmarginPC  : byte = 10;
    ratioPC : byte = 50;
    imagefilename : string;

procedure Bm2ToBox;
var sr,dr : Trect;
begin
 sr := rect(xbias,ybias,Xbias+1200,Ybias+900);
 dr := rect(0,0,1200,900);
 form1.PaintBox1.canvas.copyrect(dr,bm2.Canvas,sr);
end;

procedure setXYbias(biasX,biasY : smallInt);
begin
 with form1 do
  begin
   Xscrollbar.Position := biasX;
   Yscrollbar.Position := biasY;
   Xbias := biasX;
   Ybias := biasY;
  end;
end;

procedure resetFramebuttons;
begin
 with form1 do
  begin
   frameBtn1.down := false;
   frameBtn2.down := false;
   frameBtn3.down := false;
  end;
 framecode := 0;
end;

procedure clearPaintbox;
begin
 with form1.PaintBox1 do with canvas do
  begin
   brush.Color := form1.Color;
   fillrect(rect(0,0,width,height));
  end;
end;

procedure clearbm1;
begin
 with bm1 do with canvas do
  begin
   brush.Style := bsSolid;
   brush.Color := form1.Color;
   fillrect(rect(0,0,width,height));
  end;
end;

procedure paintframe1;
//unicolor in bm1
var x,y : smallInt;
    i : byte;
begin
 x := bm1.Width-1;
 y := bm1.height-1;
 with bm1.canvas do
  begin
   pen.color := $6060c0;
   pen.width := 1;
   for i := 0 to 11 do
    begin
     moveto(i,i);
     lineto(i,y-i);
     lineto(x-i,y-i);
     lineto(x-i,i);
     lineto(i,i);
    end;
  end;
end;

procedure paintframe2;
//2 color in bm1
var x,y : smallInt;
    i : byte;
begin
 x := bm1.Width-1;
 y := bm1.height-1;
 with bm1.canvas do
  begin
   pen.width := 1;
   for i := 0 to 11 do
    begin
     pen.color := $303080;
     moveto(x-i,i);
     lineto(i,i);
     lineto(i,y-i);
     pen.color := $6060c0;
     lineto(x-i,y-i);
     lineto(x-i,i);
    end;
  end;
end;

procedure paintframe3;
//3D in bm1
var x,y : smallInt;
    i   : byte;
begin
 x := bm1.Width-1;
 y := bm1.height-1;
 with bm1.canvas do
  begin
   pen.width := 1;
   for i := 0 to 11 do
    begin
     pen.color := $8080c0-i*$060606;
     moveto(x-i,i);
     lineto(i,i);
     lineto(i,y-i);
     pen.color := $5050a0+i*$060606;
     lineto(x-i,y-i);
     lineto(x-i,i);
    end;
  end;
end;

procedure paintRatioBM;
//show settings of margins, ratio
var i : byte;
    x1,y1,x2,y2 : smallInt;
    OK : boolean;
begin
 with ratioBM do with canvas do
  begin
   x1 := 0;
   y1 := 0;
   x2 := width-1;
   y2 := height-1;
   brush.color := $ffffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   pen.color := $000000;
   pen.Width := 1;
   for i := 0 to 1 do
    begin
     moveto(i,i);
     lineto(i,y2-i);
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
     lineto(i,i);
    end;
   pen.Width := 2;
   with form1 do
    OK := (leftmarginpc + ratiopc < 100) and
          (topmarginpc + ratiopc < 100);
   if OK then
    begin
     PIPdimensions(x1,y1,x2,y2);
     moveto(x1,y1);
     lineto(x1,y2);
     lineto(x2,y2);
     lineto(x2,y1);
     lineto(x1,y1);
     pen.width := 1;
     moveto(0,0);
     lineto(x1,y1);
     moveto(0,height-1);
     lineto(x1,y2);
     moveto(width-1,0);
     lineto(x2,y1);
     moveto(width-1,height-1);
     lineto(x2,y2);
    end;
  end;
end;

procedure adjustScrollbars;
begin
 with form1 do
  begin
   if bm1.Width > 1200 then Xscrollbar.Max := bm1.Width-1200
    else xscrollbar.Max := 0;
   Xscrollbar.Position := 0;
   if bm1.Height > 900 then Yscrollbar.Max := bm1.Height-900
    else Yscrollbar.max := 0;
  Xscrollbar.position := 0;
  Yscrollbar.position := 0;
 end;
 Xbias := 0;
 Ybias := 0;
end;

procedure removeframe;
var Hmap : Tbitmap;
begin
 Hmap := TBitmap.create;
 with Hmap do
  begin
   width := bm1.width;
   height := bm1.height;
   canvas.draw(0,0,bm1);
  end;
 bm1.Width := bm1.Width-2*framewidth;
 bm1.Height := bm1.Height-2*framewidth;
 bm1.Canvas.Draw(-framewidth,-framewidth,Hmap);
 bm2.Height := bm1.Height;
 bm2.Width := bm1.Width;
 Hmap.Free;
end;

procedure makeframespace;
var Hmap : Tbitmap;
begin
 Hmap := TXbitmap.Create;
 with Hmap do
  begin
   width := bm1.Width;
   height := bm1.Height;
   canvas.Draw(0,0,bm1);
  end;
  bm1.Width := bm1.Width+2*framewidth;
  bm1.Height := bm1.Height+2*framewidth;
  bm2.Width := bm1.Width;
  bm2.Height := bm1.Height;
  bm1.canvas.draw(framewidth,framewidth,Hmap);
  Hmap.Free;
end;

//--- image loading and saving ---

function loadImage2(map : TXBitmap; const fn : string) : boolean;
//load map from file fn
//return true if OK
var s : string;
    jpegImage : TJpegImage;
begin
 result := false;
 s := lowercase(extractFileExt(fn));
 if s = '.jpg' then
  try
   jpegImage := TJpegImage.Create;
   JpegImage.LoadFromFile(fn);
   map.Width := jpegimage.Width;
   map.Height := jpegimage.Height;
   map.Canvas.Draw(0,0,jpegimage);
   jpegimage.Free;
   result := true;
  except
  end;
  if s = '.bmp' then
   try
    map.loadfromfile(fn);
    map.XAdjust;
    result := true;
   except
   end;
end;

function loadImage(map : TXBitmap; var imfilename : string ) : boolean;
//load map from file and return true if successfull
begin
 result := false;
 with form1.opendialog1 do
  if execute then
   if loadImage2(map,filename) then
    begin
     imfilename := filename;   //save filename for reload
     result := true;
   end;
end;

procedure TForm1.loadBtnClick(Sender: TObject);
//open .bmp  .jpg   files
//load picture
var OK : boolean;//dummy
begin
 if loadImage(bm1,imagefilename) then
  begin
   clearpaintbox;
   imageloaded := true;
   bm2.Width := bm1.Width;
   bm2.height := bm1.Height;
   adjustscrollbars;
   bm2.Canvas.draw(0,0,bm1);
   bm2toBox;
   setImagedimensions(bm1);
  end
  else popmessage(pmQuickmessage,'image not loaded',OK);
end;

procedure TForm1.pipBtnClick(Sender: TObject);
//load picture-in-picture
var OK : boolean;//dummy
    Hmap : TXBitmap;
    pipname : string;
begin
 if imageloaded = false then
  begin
   popmessage(pmQuickmessage,'load image first',OK);
   exit;
  end;
 HMap := TXBitmap.create;
 if loadImage(Hmap,pipname) then InsertPIPimage(Hmap);
 Hmap.Free;
end;

procedure TForm1.saveBtnClick(Sender: TObject);
var OK : boolean; //dummy
begin
 if imageloaded then
  begin
   with savedialog1 do
    if execute then
     begin
      bm2.savetofile(filename);
      popmessage(pmQuickmessage,'image saved',OK);
     end;
   end
  else popmessage(pmMessage,'no file loaded',OK);
end;

procedure TForm1.reloadBtnClick(Sender: TObject);
var OK : boolean;//dummy
begin
 if imageloaded then
  if loadImage2(bm1,imagefilename) then
   begin
    clearpaintbox;
    setimagedimensions(bm1);
    bm2.Canvas.Draw(0,0,bm1);
    Xscrollbar.Position := 0;
    Yscrollbar.Position := 0;
    resetFrameButtons;
    bm2toBox;
   end
   else popmessage(pmMessage,'no image loaded',OK);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 createbitmaps;
 ratioBM := Tbitmap.Create;
 with ratioBM do
  begin
   width := paintbox2.Width;
   height := paintbox2.Height;
   pixelformat := pf15bit;
  end;
 setratios(leftmarginpc,topmarginpc,ratiopc);
 paintRatioBM;
 paintbox1.Canvas.Draw(0,0,ratioBM);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 destroybitmaps;
 ratioBM.Free;
end;

procedure TForm1.frameBtn1Click(Sender: TObject);
//common for all frameButtons
begin
 with Tspeedbutton(sender) do
  begin
   if down then begin
                 if framecode = 0 then makeframespace;
                 case tag of
                  1 : paintframe1;
                  2 : paintframe2;
                  3 : paintframe3;
                 end;
                 framecode := tag;
                end
    else if framecode <> 0 then begin
                                 removeframe;
                                 framecode := 0;
                                 clearpaintbox;
                                end;
  end; //with
  adjustscrollbars;
  bm2.canvas.Draw(0,0,bm1);
  bm2toBox;
  setimagedimensions(bm1);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 Bm2ToBox;
end;

procedure TForm1.yscrollbarChange(Sender: TObject);
begin
 case Tscrollbar(sender).Tag of
  1 : Xbias := Xscrollbar.position;
  2 : Ybias := Yscrollbar.position;
 end;
 bm2toBox;
end;

procedure TForm1.GObtnClick(Sender: TObject);
var OK : boolean;//dummy
begin
 if imageloaded then insertImage
  else popmessage(pmQuickmessage,'no image loaded',OK);
end;

procedure TForm1.PaintBox2Paint(Sender: TObject);
begin
 paintbox2.Canvas.Draw(0,0,ratioBM);
end;

procedure showPIPsettings;
begin
 with form1 do
  begin
   leftlabel.Caption := inttostr(leftmarginPC);
   toplabel.Caption := inttostr(topmarginPC);
   ratiolabel.Caption := inttostr(ratioPC);
   paintratioBM;
   paintbox2.Canvas.Draw(0,0,ratioBM);
  end; 
end;

procedure showPIPwindow;
//on paintbox1
var x1,y1,x2,y2 : smallInt;
begin
 bm2tobox;
 x1 := 0; y1 := 0;
 x2 := bm1.Width-1; y2 := bm1.Height-1;
 PIPdimensions(x1,y1,x2,y2);
 x1 := x1 - Xbias + 1;
 y1 := y1 - Ybias + 1;
 x2 := x2 - Xbias - 1;
 y2 := y2 - Ybias - 1;
 with form1.PaintBox1.Canvas do
  begin
   pen.Color := $ff;
   pen.Width := 2;
   moveto(x1,y1);
   lineto(x1,y2);
   lineto(x2,y2);
   lineto(x2,y1);
   lineto(x1,y1);
  end;
end;

procedure resetPIPrates;
begin
 leftmarginPC := defaultleftpc;
 topmarginPC  := defaulttoppc;
 ratioPC := defaultratiopc;
 with form1 do
  begin
   leftRotationBtn.position := leftmarginPC-5;
   topRotationBtn.position := topmarginPC-5;
   ratioRotationBtn.position := ratioPC-20;
  end;
 setratios(leftmarginpc,topmarginpc,ratiopc);
 showPIPsettings;
end;

procedure TForm1.pipresetBtnClick(Sender: TObject);
begin
 resetPIPrates;
end;

procedure TForm1.leftrotationBtnChange(sender: TObject; position: Byte);
//common for all rotation buttons
begin
 with TDav7RotationBtn(sender) do
  case tag of
   1 : leftmarginPC := position + 5;
   2 : topmarginPC := position + 5;
   3 : ratioPC := position + 20;
 end;
 setratios(leftmarginpc,topmarginpc,ratiopc);
 showPIPsettings;
 showPIPwindow;
end;

procedure TForm1.clearBtnClick(Sender: TObject);
begin
 imageloaded := false;
 clearbm1;
 bm2.Canvas.draw(0,0,bm1);
 setXYbias(0,0);
 bm2toBox;
 resetframebuttons;
 resetPIPrates;
 showPIPsettings;
end;

end.
