unit message_Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TmessageForm = class(TForm)
    msglabel: TLabel;
    Timer1: TTimer;
    escapelabel: TLabel;
    NoButton: TSpeedButton;
    YesButton: TSpeedButton;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure NObuttonClick(Sender: TObject);
    procedure YesbuttonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  TpopMessage = (pmQuickMessage,pmMessage,pmWarning,pmError,pmYNQuestion,
                 pmApprove);

var
  messageForm: TmessageForm;

procedure popMessage(pmtype : TPopMessage; pmString : string; var pmOK : boolean);

implementation

uses Unit1;

{$R *.dfm}

procedure paintframe;
//paint edge around form
var i : byte;
    w,h : word;
begin
 with messageform do with canvas do
  begin
   w:= width-1;
   h := height - 1;
   pen.Width := 1;
   for i := 0 to 2 do
    begin
     pen.Color := $f0f0f0 - $404040*i;
     moveto(w-i,i);
     lineto(i,i);
     lineto(i,h-i);
     pen.Color := $707070 + $404040*i;
     lineto(w-i,h-i);
     lineto(w-i,i);
    end;
  end;
end;

procedure QuickMessageProc;
begin
 with messageform do
  begin
   escapelabel.visible := false;
   NObutton.visible := false;
   YESbutton.visible := false;
   msglabel.font.color := $ff0000;
   timer1.interval := 1000;
   timer1.enabled := true;
  end;
end;

procedure MessageProc;
begin
 with messageForm do
  begin
   YESbutton.visible := false;
   NObutton.visible := true;
   NObutton.Caption := 'close';
   msglabel.font.Color := $000000;
  end;
end;

procedure WarningProc;
begin
 with messageform do
  begin
   YESbutton.visible := false;
   NObutton.visible := true;
   NObutton.Caption := 'close';
   msglabel.font.color := $ff00ff;
  end;
end;

procedure ErrorProc;
begin
 with messageform do
  begin
   msglabel.font.Color := $0000ff;
   YESbutton.visible := false;
   NObutton.visible := true;
   NObutton.Caption := 'close';
  end;
end;

procedure YNQuestionProc;
begin
 with messageform do
  begin
   YESbutton.visible := true;
   NObutton.visible := true;
   msglabel.font.color := $008000;
  end;
end;

procedure ApproveProc;
begin
 with messageform do
  begin
   msglabel.Font.color := $ff0000;
   YESbutton.visible := true;
   NObutton.Visible := true;
  end;
end;

procedure popMessage(pmtype : TPopMessage; pmString : string; var pmOK : boolean);
begin
 with messageForm do
  begin
   left := form1.left + form1.paintbox1.left + 200;
   top := form1.top + form1.paintbox1.top + 200;
   YESbutton.caption := 'YES';
   NObutton.caption := 'NO';
   escapelabel.Visible := true;
   case pmType of
    pmQuickMessage : QuickMessageProc;
    pmMessage      : MessageProc;
    pmWarning      : WarningProc;
    pmError        : ErrorProc;
    pmYNQuestion   : YNQuestionProc;
    pmApprove      : ApproveProc;
   end;
   msglabel.caption := pmString;
   showmodal;
   pmOK := messageForm.modalresult = mrOK;
  end;
end;

procedure TmessageForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key = VK_ESCAPE then modalResult := mrCancel;
end;

procedure TmessageForm.Timer1Timer(Sender: TObject);
begin
 timer1.enabled := false;
 modalresult := mrCancel;
end;

procedure TmessageForm.FormPaint(Sender: TObject);
begin
 paintframe;
end;

procedure TmessageForm.NObuttonClick(Sender: TObject);
begin
 modalresult := mrCancel;
end;

procedure TmessageForm.YesbuttonClick(Sender: TObject);
begin
 modalresult := mrOK;
end;

end.


