unit rip_unit;

{
  RIP : Recursive Image Project
}

interface

uses xbitmap_unit,types,graphics;

procedure createbitmaps;
procedure destroybitmaps;
procedure setImageDimensions(map : TXbitmap);
procedure setratios(lpc,tpc,rpc : byte);
procedure insertImage;
procedure InsertPIPimage(map : TXBitmap);
procedure PIPdimensions(var x1,y1,x2,y2 : smallInt);

var bm1,bm2 : TXbitmap;
    imageloaded : boolean;
    pipratio : single; //image seize fraction
    pipleft  : single; //fraction of image width
    piptop   : single; //fraction of image height

implementation

uses unit1;

var ripx1,ripy1,ripx2,ripy2 : smallInt; //pip coordinates

procedure setratios(lpc,tpc,rpc : byte);
begin
 pipleft := lpc*0.01;
 piptop := tpc*0.01;
 pipratio := rpc*0.01;
end;

procedure setImageDimensions(map : TXBitmap);
begin
 ripx1 := 0;
 ripy1 := 0;
 ripx2 := map.Width-1;
 ripy2 := map.Height-1;
end;

procedure PIPdimensions(var x1,y1,x2,y2 : smallInt);
var w,h,dx,dy: smallInt;
begin
 dx := x2 - x1;
 dy := y2 - y1;
 if (dx > 20) and (dy > 20) then
  begin
   w := round(dx*pipratio);
   h := round(dy*pipratio);
   x1 := round(x1 + dx*pipleft);
   x2 := x1 + w - 1;
   y1 := round(y1 + dy*piptop);
   y2 := y1 + h - 1;
  end; 
end;

procedure InsertImage;
var rsource,rdest : Trect;
begin
 PIPdimensions(ripx1,ripy1,ripx2,ripy2);
 with bm2 do
  begin
   Xstretchmode := smFulldest;
   rsource := rect(0,0,bm1.width,bm1.height);
   rdest := rect(ripx1,ripy1,ripx2+1,ripy2+1);
   bm2.XstretchRect(rdest,bm1,rsource);
   bm2tobox;
  end;
end;

procedure InsertPIPimage(map : TXBitmap);
var PIPmap : TXBitmap;
//    x1,y1,x2,y2 : smallInt;
    srect,drect : Trect;
begin
 setImageDimensions(bm1);
 PIPdimensions(ripx1,ripy1,ripx2,ripy2);
 PIPmap := TXBitmap.create;
 with PIPmap do
  begin
   width := ripx2 - ripx1 + 1;
   height := ripy2 - ripy1 + 1;
   canvas.brush.Style := bsSolid;
   canvas.brush.Color := $f0f0f0;
   canvas.fillrect(rect(0,0,width,height)); //erase PIPmap
   srect := rect(0,0,map.width,map.height);
   drect := rect(5,5,width-5,height-5);   //5 pixels white frame added
   Xstretchmode := smFulldest;
   pipmap.Xstretchrect(drect,map,srect);
   Bm1.canvas.Draw(ripx1,ripy1,pipmap);
   bm2.Canvas.Draw(0,0,bm1);
   bm2tobox;
   pipmap.Free;
   setImageDimensions(bm1);//restore PIP window
  end;
end;

//-- create -- destroy --

procedure createbitmaps;
begin
 bm1 := TXBitmap.create;
 with bm1 do
  begin
   width := 100;
   height := 100;
  end;
 bm2 := TXbitmap.create;
 with bm2 do
  begin
   width := 100;
   height := 100;
  end;
end;

procedure destroybitmaps;
begin
 bm1.free;
 bm2.free;
end;

end.
